
#ifndef RDFDB_SERVER_CONNECTION_H
#define RDFDB_SERVER_CONNECTION_H

#include "security.h"
#include "../utils/socketstream.h"

/* JvdG Not needed?: typedef enum {
  CONNECTION_ALIVE,
  CONNECTION_ENDED
} ClientStatus; */

typedef struct _NamespaceStruct {
  char* prefix;
  char* url;
  struct _NamespaceStruct *next;
} NamespaceStruct;

typedef NamespaceStruct *Namespace;

void freeNamespace(Namespace ns);

/* JvdG Renamed socket to raw_socket and added a socket_stream. */
typedef struct _ClientConnectionStruct {
  struct _ClientConnectionStruct* next;
  SOCKET raw_socket;
  socket_stream_t* socket_stream;
  /* JvdG Not needed?: ClientStatus status; */
  Namespace namespaces;
  security_context_t* security_context; /* JvdG Added to allow rights to be checked whenever a query is issued. */
  unsigned int index;
} ClientConnectionStruct;

typedef ClientConnectionStruct *ClientConnection;

int init_connection();
int deinit_connection();

ClientConnection new_client_connection(SOCKET socket, unsigned int ipv4address);

#endif/*RDFDB_SERVER_CONNECTION_H*/